#include "colors.inc"
#include "glass.inc"
#include "stones.inc"
#include "stars.inc"
#include "metals.inc"
#include "finish.inc"

#declare remote=
union {
  difference {
    sphere { 0, 3.14 texture { T_Glass3 } }
    sphere { 0, 3.115 texture { T_Glass3 } }
  }
  torus { 3, .15 texture { T_Stone8 } }
  difference {
    sphere { 0, 2.75 texture { T_Stone10 } }
    plane { <0, -1, 0>, 0 texture { T_Stone10 } }
  }
  torus { 2.5, 0.125 texture { T_Glass2 } translate <0, 0.25, 0> }
  torus { 2.5, 0.025 pigment { Orange } finish { ambient 1 diffuse 0 } translate <0, 0.25, 0> }
  sphere { <-1, 0, 0>, 1 texture { Starfield6 scale 0.5} }
  union {
    cylinder { <0, -1, 0>, <0, 3.01, 0> 0.25 texture { T_Chrome_2A } }
    cone { <0, 1.2, 0>, 0.15, <1.5, 1.2, 0> 0.05 texture { T_Chrome_2A } }
    difference {
      sphere { 0, 0.5 }
      sphere { <1.2, 0, 0>, 1.5}
      texture { T_Silver_3C
        normal {
          quilted 1
          control0 1.0
          control1 0.25
        }
        scale 0.1
      }
      scale <2.5, 2, 2>
      translate <2, 1.2, 0>
    }
    sphere { <1.5, 1.2, 0>, 0.15 pigment { Black } finish { Glossy } }
    rotate y * 50
  }
  union {
    box { <-1.5, 0, .75>, <1.5, 1, 1.5> texture { T_Silver_2A } }
    box { <-1.4, 1, .80>, <-1, 1.1, 1> texture { T_Gold_3C } }
    box { <-0.9, 1, .80>, <-0.5, 1.1, 1> texture { T_Gold_3C } }
    box { <-1.4, 1, 1.13>, <-0.5, 1.1, 1.45> texture { T_Gold_3C } }
    rotate y * 45
  }
  union {
    difference {
      box { <-3, -0.25, -0.75>, <-3.5, 0.25, 0.75> pigment { Black } finish { Glossy } }
      cylinder { <-3.25, 0, -0.76>, <-3.25, 0, -0.7>, 0.2 pigment { Black } finish { Glossy } }
      sphere { <-3.25, 0, -0.7>, 0.2 texture { T_Silver_3C } }
    }
    light_source { <-3.25, 0, -0.69> color White
      spotlight
      point_at <-6, 0, -10>
      radius 50
      falloff 50
      tightness 1
    }
    //rotate y * -15
  }
  union {
    difference {
      box { <3, -0.25, -0.75>, <3.5, 0.25, 0.75> pigment { Black } finish { Glossy } }
      cylinder { <3.25, 0, -0.76>, <3.25, 0, -0.7> 0.2 pigment { Black } finish { Glossy } }
      sphere { <3.25, 0, -0.7>, 0.2 texture { T_Silver_3C } }
    }
    light_source { <3.25, 0, -0.69> color White
      spotlight
      point_at <6, 0, -10>
      radius 50
      falloff 50
      tightness 1
    }
    //rotate y * 15
  }
  sphere { 0, 1
    no_shadow
    texture { T_Glass3 normal { quilted 1 control0 1.0 control1 0.25 } scale 0.05 }
    hollow
    halo {
      emitting
      linear
      spherical_mapping
      color_map {
        [ 0 color MidnightBlue ]
        [ 0.2 color MidnightBlue ]
        [ 0.4 color SummerSky ]
        [ 0.7 color White ]
        [ 1 color White ]
      }
      samples 10
    }
    scale 0.2
    translate <-3.25, 0, -0.725>
    //rotate y * -15
  }
  sphere { 0, 1
    no_shadow
    texture { T_Glass3 normal { quilted 1 control0 1.0 control1 0.25 } scale 0.05 }
    hollow
    halo {
      emitting
      linear
      spherical_mapping
      color_map {
        [ 0 color MidnightBlue ]
        [ 0.2 color MidnightBlue ]
        [ 0.4 color SummerSky ]
        [ 0.7 color White ]
        [ 1 color White ]
      }
      samples 10
    }
    scale 0.2
    translate <3.25, 0, -0.725>
    //rotate y * 15
  }
  sphere { 0, 1
    texture { T_Glass2 }
    hollow
    halo {
      emitting
      linear
      spherical_mapping
      color_map {
        [ 0 color Red ]
        [ 0.05 color Orange ]
        [ 0.2 color Yellow ]
        [ 0.3 color White ]
        [ 1 color White ]
      }
      scale 0.75
      samples 10
    }
    scale 0.45
    translate <0, 3.05, 0>
  }
}
